
  //  (c) Drobotenko    http://drobotenko.com


/////////////////////////////////////////
extern int gaus_ostatok;
extern double  gaus_minved,gaus_deter;
#ifndef  ASSERT
#define ASSERT(T) if(!(T)){__asm int 03\
                                       };
#
//#undef  ASSERT
//#define ASSERT(T) 
#endif
inline double _NaN()
{  unsigned long nan[2]={0xffffffff, 0x7fffffff};
   return *( double* )nan;
}
/*
inline int _isnan(double d)
{  int zr[2]={0,0};
   d-=d;//!!!!!!!
   ((float&)(zr[0]))= float(d*.0);
   return zr[0]||zr[1];
}
*/
template <class A>
 inline int dimA(A   &a){ return sizeof(a)/sizeof(a[0]);}
template <class A>
 inline int dimB(A   &a){ return sizeof(a[0])/sizeof(a[0][0]);}

struct DVec
{  double *p;
   int size;
   inline int memsz(){return size*sizeof(double);}
   DVec():p(0),size(0){}
   explicit DVec(int size):size(size)
   {  p=size?(double*)malloc(size*sizeof(double)):0;
      for(int j=size;j--;)
        p[j]=_NaN();
   };
   DVec(double *p,int size):p(p),size(size){};
   template <class A>
    DVec(A const &a)
    { p=const_cast<double*>(&*a),size=dimA(a);
    }
   inline DVec(struct DSVec &a);
   inline void set(double d=_NaN())
   { for(int j=size;j--;)
       p[j]=d;
   }; 

   //inline operator  double  *(){return p;}; 
   inline double & operator[](int j)
   {  ASSERT(unsigned(size)>unsigned(j))
      return p[j];  
   }
   inline DVec& resize(int s=0)
   {  if(!s)
        free(p),p=0;
      else
        p=(double*)realloc(p,sizeof(double)*s);
      size=s;
      return *this;
   }      
   struct iterator_at;
   iterator_at at(int,int);
};
struct DVec::iterator_at:public DVec
{  inline iterator_at& operator,(double const &v)
   {  ASSERT(size>0);
      p++[0]=v;size--;
      return *this;
   }
  inline iterator_at& operator=(double const &v)
   {  operator,(v);
      return *this;
   }

   inline iterator_at& operator,(DVec  &v)
   {  for(int j=0;j<v.size&&size>0;j++)
        p++[0]=v[j],size--;
      return *this;
   }   
   inline iterator_at& operator=(DVec  &v)
   {  operator,(v);
      return *this;
   }

   inline iterator_at& operator,(iterator_at  &v)
   {  operator,((DVec&)v);
      return *this;
   }   
   inline iterator_at& operator=(iterator_at  &v)
   {  operator,((DVec&)v);
      return *this;
   }
};

DVec::iterator_at DVec::at(int i=0,int l=0)
{  DVec r(p+i,size-i);
   if(l)// l   
   { ASSERT(l>= r.size)
     r.size=l; 
   }
   return (DVec::iterator_at&)r;
}

struct DSVec:public DVec
{  DSVec(int size=0):DVec(size){};
   ~DSVec(){free(p);}
   operator DVec&();
   private:
   void operator=(DSVec);
   void operator=(DVec);
};
inline DVec::DVec(struct DSVec &a)
{ *this=a;
};

struct DMat
{  double *p;
   int size,sizeB;
   inline int memsz(){return size*sizeB*sizeof(double);}
   explicit DMat(int size):size(size),sizeB(size)
   {  p=size?(double*)malloc(size*sizeB*sizeof(double)):0;
      for(int j=size*sizeB;j--;)
        p[j]=_NaN();
   };
   DMat(int size,int sizeB):size(size),sizeB(sizeB)
   {  p=size?(double*)malloc(size*sizeB*sizeof(double)):0;
      for(int j=size*sizeB;j--;)
        p[j]=_NaN();
   };
   DMat(double *p,int size):p(p),size(size),sizeB(size){} 
   DMat(double *p,int size,int sizeB):p(p),size(size),sizeB(sizeB){} 

   DMat():p(0),size(0){}; 
   template <class A>
    DMat(A  &a)
    { p=const_cast<double*>(&a[0][0]),size=dimA(a),sizeB=dimB(a);
    }
   DMat( DMat &o):p(o.p),size(o.size),sizeB(o.sizeB) {}
   DMat& resize(int s=0)
   {  if(!s)
        free(p),p=0;
      else
        p=(double*)realloc(p,sizeof(double)*s*s);
      size=sizeB=s;
      return *this;
   }           
   inline DMat& set(double d=_NaN())
   { for(int j=size*sizeB;j--;)
       p[j]=d;
       return *this;
   }; 
   inline DVec operator[](int j)
   {  ASSERT(unsigned(size)>unsigned(j));
      return DVec(p+j*sizeB,sizeB);  
   }
   inline double& operator()(int j,int k) // fast [][]
   {  if(unsigned(size)<=unsigned(j)||unsigned(sizeB)<=unsigned(k))
         __asm int 03;
      return p[j*sizeB+k];  
   }
   DVec::iterator_at at(int,int,int); //  

};
struct DSMat:public DMat
{  DSMat(int size):DMat(size){};
   DSMat(int size,int sizeB):DMat(size,sizeB){};
 
   ~DSMat(){free(p);}
   operator DMat&();
   private:
   void operator=( DSMat);
   void operator=( DMat);
};
DVec::iterator_at DMat::at(int i=0,int j=0,int l=0)
{  i=i*size+j;
   DVec r(p+i,size*sizeB-i);
   if(l)//  l  
   { ASSERT(l>= r.size)
     r.size=l; 
   }
   return (DVec::iterator_at&)r;
}

template <>
 inline int dimA( double  *&){ return 1<<(sizeof(void*)*8-2);}

template <>
 inline int dimA( DVec  &a){ return a.size;}
template <>
 inline int dimA( DMat  &a){ return a.size;}
template <>
 inline int dimB( DMat  &a){ return a.sizeB;}

template <>
 inline int dimA( DSVec  &a){ return a.size;}
template <>
 inline int dimA( DSMat  &a){ return a.size;}
template <>
 inline int dimB( DSMat  &a){ return a.sizeB;}

std::ostream& operator<<(std::ostream & stream, DVec &m)
  { for(int j=0;j<dimA(m);j++)
      stream<<m.p[j]<<" ";  
    return stream<<"\n";
  }
std::ostream& operator<<(std::ostream & stream, DMat &m)
  { for(int j=0;j<dimA(m);j++,stream<<"\n")
    for(int k=0;k<dimB(m);k++)
      stream<<(m.p[j*m.size+k])<<" ";  
    return stream<<"\n";
  }
// typeof 
template <int> struct id_2_type {};
#define REG_TYPE(R,N) template <> struct id_2_type<N> { typedef R T; }; char (& get_type_id(R ))[N];
#define GET_TYPE(v) id_2_type<sizeof(get_type_id(v))>::T

REG_TYPE(int,__LINE__);
REG_TYPE(float,__LINE__);
REG_TYPE(double,__LINE__);

namespace La
{  template <typename T> inline T min(T const &a,T const b){return a<b?a:b;}
   template <typename T> inline T max(T const &a,T const b){return a>b?a:b;}
   inline static void simmetric(DMat &m)
   { int RAZM=dimA(m);ASSERT(RAZM==dimB(m));
     for(int j=0;j<RAZM;j++) for(int k=j+1;k<RAZM;k++)
       m[j][k]=m[k][j]=(m[j][k]+m[k][j])/2;
   }
   inline static  double form(double *a,DMat &m,double * b)
   { double r=0.;
     for(int j=0;j<m.size;j++)for(int k=0;k<m.sizeB;k++)
       r+=a[j]*m[j][k]*b[k];
     return r;
   }
   inline static int matvec(DVec  _rez, DMat  matr,DVec  vec)
   { int row=min(dimA(_rez), dimA(matr))
        ,col=min(dimB(matr), dimA(vec))
        ,exact=  dimA(_rez)==dimA(matr)
               &&dimB(matr)==dimA(vec)  ;
     int r,k;     
     double *rez=(double *)alloca(row*sizeof(*rez)); 
     for(r=0;r<row;r++)
     { rez[r]=0;
       for(k=0;k<col;k++)
         rez[r]+=matr[r][k]*vec[k];
     }
     for(k=row;k--;)
      _rez[k]=rez[k];
     return exact;  
   }
   inline static  int matmat(DMat c, DMat  a,DMat  b)
   { int  row=min(dimA(c), dimA(a))
         ,rc =min(dimB(a), dimA(b))
         ,col=min(dimB(c), dimB(b));
     int exact=   dimA(c)==dimA(a)
                &&dimB(a)==dimA(b)
                &&dimB(c)==dimB(b);  

     DMat mc(0,row,col);
     mc.p=(double *)alloca(sizeof(double)*row*col);

     int r,k,j0;
     for(r=row;r--;) 
     for(k=col;k--;)
     for(mc[r][k]=0,j0=rc;j0--;)
         mc[r][k]+=a[r][j0]*b[j0][k];
     for(r=row;r--;) 
     for(k=col;k--;)
         c[r][k]=mc[r][k];
     return exact;
   }
   inline static  void copy(DVec  &d,DVec  const &s)
   {  memcpy(d.p,s.p, d.memsz());
   }
   inline static  void copy(DMat  &d,DMat  &s)
   {  memcpy(d.p,s.p, d.memsz());
   }
   inline static  void gaus(DVec  r,DMat _m,DVec  _v)
     {
       int N=_m.size;
       ASSERT(r.size==N && N==_v.size)
       DMat m(0,N,N);
       m.p=(double *)alloca(_m.memsz()); copy(m,_m);
       DVec v(0,N);
       v.p=(double *)alloca(_v.memsz()); copy(v,_v); 

       int *num= (int*)alloca(sizeof(int)*N);
       int j,jj,k;
       for(j=N;j--;)
          num[j]=j;
       register  double vmax,aa; int jmax,kmax;
       vmax=-1;
       double t;
       for(j=N;j--;) for(k=N;k--;)
       if(vmax<(t=fabs(m[j][k])))
          vmax=t,jmax=j,kmax=k;

       gaus_ostatok=N;
       gaus_minved=vmax; gaus_deter=vmax;
       if(vmax<1e-99)
         goto final_;
       gaus_ostatok--;

       for(j=N;j--;)
          t=m[j][kmax],m[j][kmax]=m[j][0],m[j][0]=t;
       for(k=N;k--;)
           t=m[jmax][k],m[jmax][k]=m[0][k],m[0][k]=t;
       t=v[jmax],v[jmax]=v[0],v[0]=t;
       num[0]=kmax;num[kmax]=0;

       for(j=0;j<N-1;j++)
       {  vmax=-1;
          for(jj=j+1;jj<N;jj++)
          {  double t=m[jj][j]/m[j][j];
             for(k=j+1;k<N;k++)
             if(vmax<(aa=fabs(m[jj][k]-=m[j][k]*t)))
                vmax=aa,jmax=jj,kmax=k;
             v[jj]-=v[j]*t;
          }
          if(gaus_minved>vmax)
            gaus_minved=vmax;
          gaus_deter*=m[jmax][kmax];
          if(vmax<1e-99)
            goto final_;
          gaus_ostatok--;

          for(jj=N;jj--;)
            t=m[jj][kmax],m[jj][kmax]=m[jj][j+1],m[jj][j+1]=t;
          for(jj=N;jj-->j;)
            t=m[jmax][jj],m[jmax][jj]=m[j+1][jj],m[j+1][jj]=t;
          t=v[j+1];v[j+1]=v[jmax];v[jmax]=t;
          jj=num[j+1];num[j+1]=num[kmax];num[kmax]=jj;
       }
       final_:
       int NF=N-gaus_ostatok; 
       for(j=NF;j--;)
       {  double s=v[j];
          for(k=j+1;k<NF;k++)
            s-=m[j][k]*m[NF-1][k];
         m[NF-1][j]=s/m[j][j];
       }
       for(j=NF;j--;)
          r[num[j]]=m[NF-1][j];
       for(j=N;j-->NF;)
          r[num[j]]=_NaN();
     }

     inline static  void  invers(DMat m)
     {
       int N= dimA(m);
       int *rn=(int*)alloca((sizeof(int))*N),*cn=(int*)alloca((sizeof(int))*N);
       //int rn[N],cn[N];

       int j,k;   

       for(j=N;j--;)
         rn[j]=cn[j]=j;
       gaus_minved=1e99;
       gaus_deter=1;
       for(gaus_ostatok=N;gaus_ostatok;gaus_ostatok--)
       {  int jved,kved;
          double vved=-1,t;
          for(j=N;j--;)
          {  if(~rn[j])
             for(k=N;k--;)
               if(~cn[k])
               if(vved<fabs(m[j][k]))
                  vved=fabs(m[j][k]),jved=j,kved=k;
          }
          if(gaus_minved>vved)
             gaus_minved=vved;
          gaus_deter*=m[jved][kved];
          if(vved<1e-99)
          {  for(j=N;j--;)
             {  if(~rn[j]) for(k=N;k--;)
                  m[j][k]=_NaN();
                if(~cn[j]) for(k=N;k--;)
                  m[k][j]=_NaN();
             }
             return;
          }
          int jt=rn[jved],kt=cn[kved];
          for(j=N;j--;)
              t=m[kt][j],m[kt][j]=m[jved][j],m[jved][j]=t;
          for(j=N;j--;)
              t=m[j][jt],m[j][jt]=m[j][kved],m[j][kved]=t;

          rn[jved]=rn[kt];
          cn[kved]=cn[jt];
          rn[kt]=cn[jt]=-1;

          vved=m[kt][jt];   m[kt][jt]=1;
          for(j=N;j--;)
          {  if(j==kt)
               continue;
             double mul=m[j][jt]/vved;
             m[j][jt]=0;
             for(k=N;k--;)
               m[j][k]-=m[kt][k]*mul;
          }
          for(k=N;k--;)
              m[kt][k]/=vved;
       }
     }    
     inline static void minus(DVec   a,DVec b,DVec c)
     { for(int j=a.size;j--;)
        a[j]=b[j]-c[j];
        
     }
     inline static void for_each(DVec  &d,  double ma, DVec &a,  double mb, DVec  &b)
     { for(int j=d.size;j--;)
          d[j]=ma*a[j]+mb*b[j];
     }
     inline static void for_each(DMat  &d,  double ma, DMat &a,  double mb, DMat  &b)
     { for(int k=d.size;k--;)
       for(int j=d.size;j--;)
          d[k][j]=ma*a[k][j]+mb*b[k][j];
     }
};

#define FOR(J,V,CODE)     {for(int J=V;J--;){CODE }}
#define FOR_M(J,K,V,CODE) {for(int J=dimA(V);J--;)for(int K=dimB(V);K--;){CODE }}
